module Noa
  module Resource
    class BaseController < Noa::Core::BaseController
      inherit_resources
      defaults route_prefix: ""

      def create
        create! { collection_url }
      end
      
      def update
        update! { collection_url }
      end

      protected

      def resource_params
        params.require(resource_name).permit(*permit_attributes)
      end

      def resource_name
        controller_name.tableize.singularize.to_sym
      end

      def permit_attributes
        resource_class.attribute_names - %w(id created_at updated_at)
      end
    end
  end
end
